
<!-- 
Thank you for contributing to the SpacePy community by
taking the time to report a SpacePy issue. Please
describe the issue in detail, and for bug reports
fill in the fields below.

You can delete the sections that don't apply to your
issue. For example, if a feature is inadequately
described, simply delete all sections below and 
describe how the documentation is lacking. If you
think you've found a bug that proudces unwanted or
incorrect behavior then delete the "Error Message"
section and include a description of what the code
along with a description of what you think it should
do. For new feature requests, please describe the 
feature and at least one possible use case (none of 
the sections below would be required in that case).

You can view the final output by clicking the preview
button above.
-->

My issue is ...

### Minimal example to reproduce issue:
<!-- 
If you place your code between the triple backticks below, 
it will be marked as a code block automatically.
If possible, please provide a minimal example that succinctly
illustrate the issue.
-->


```
Sample code to reproduce the problem
```

### Error message/Traceback:
<!-- If any, paste the *full* error message inside a code block
as above (starting from line Traceback)
-->

```
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  ...
```

### OS, Python version, and dependency version information:
<!-- You can run the following and paste the result in a code 
block.
```
import platform
import sys
import numpy
import scipy
import matplotlib

print(platform.platform())
print(sys.version_info)
print('numpy={0}'.format(numpy.__version__))
print('scipy={0}'.format(scipy.__version__))
print('matplotlib={0}'.format(matplotlib.__version__))
```
-->

### Version of SpacePy
<!-- What version of SpacePy are you using and where did you
download it from?
-->
